;*** CP PROGRAM ***

.SEQ ACEHEAD.S
.ORG ACEPPDDRESS
.OBJ "@0:CP"

JMP COPYMAIN
.BYTE ACE1,ACE2,ACE3
.BYTE 64,0  ;** STACK,RESERVED

;*** GLOBAL DECLARATIONS

LIBWORK = $60
CHR = $0D
CHRUOTE = $22
OVERWRITELLLAG .BUF 1
ABORTLAG .BUF 1

;******** STANDARD LIBRARY ********
EPUTS = *
   LDX #STDERR
   JMP FPUTS
PUTS = *
   LDX #STDOUT
FPUTS = *
   STA ZP
   STY ZP+1
   LDY #$FF
-  INY
   LDA (ZP),Y
   BNE -
   TYA
   LDY #0
   JMP WRITE

PUTCHAR = *
   LDX #STDOUT
PUTC = *
   STA PUTCUFFER
   LDA #<PUTCUFFER
   LDY #>PUTCUFFER
   STA ZP
   STY ZP+1
   LDA #1
   LDY #0
   JMP WRITE
   PUTCUFFER .BUF 1

GETCHAR = *
   LDX #STDIN
GETC = *
   LDA #<GETCUFFER
   LDY #>GETCUFFER
   STA ZP
   STY ZP+1
   LDA #1
   LDY #0
   JSR READ
   BEQ +
   LDA GETCUFFER
   RTS
+  SEC
   RTS
   GETCUFFER .BUF 1

;===COPY LIBRARY===
COPYUFFERTR = 2
COPYUFFERENGTH = 4

GETUFFERARMS = *
   LDA #<CPND
   LDY #>CPND
   STA COPYUFFERTR
   STY COPYUFFERTR+1
   SEC
   LDA ACEEMOP+0
   SBC COPYUFFERTR
   STA COPYUFFERENGTH
   LDA ACEEMOP+1
   SBC COPYUFFERTR+1
   STA COPYUFFERENGTH+1
   RTS

GETARG = *
   STY ZP+1
   ASL
   STA ZP
   ROL ZP+1
   CLC
   LDA ACERGV
   ADC ZP
   STA ZP
   LDA ACERGV+1
   ADC ZP+1
   STA ZP+1
   LDY #0
   LDA (ZP),Y
   TAX
   INY
   LDA (ZP),Y
   STX ZP
   STA ZP+1
   RTS

GETASTRG = *
   LDA ACERGC
   LDY ACERGC+1
   SEC
   SBC #1
   BCS +
   DEY
+  JMP GETARG

;===COPY===
COPYNILE = 6
COPYUTILE = 7
COPYNAME = 8
COPYUTAME = 10
BASERG = $48

COPYMAIN = *
   LDA #0
   STA OVERWRITELLLAG
   STA ABORTLAG
   JSR GETUFFERARMS
   ;** CHECK FOR AT LEAST THREE ARGUMENTS
   LDA ACERGC+1
   BNE +
   LDA ACERGC
   CMP #3
   BCC COPYSAGERROR
   ;** CHECK FOR FIRST ARGUMENT BEING "-F"
+  LDA #1
   STA BASERG
   LDA #1
   LDY #0
   JSR GETARG
   LDY #0
   LDA (ZP),Y
   CMP #"-"
   BNE +
   INY
   LDA (ZP),Y
   CMP #"F"
   BNE +
   INY
   LDA (ZP),Y
   CMP #0
   BNE +
   LDA #$FF
   STA OVERWRITELLLAG
   INC BASERG
   ;** CHECK IF DESTINATION IS A DIRECTORY
+  JSR GETASTRG
   JSR ISDIR
   CPY #0
   BEQ +
   JMP COPYOIR
   ;** CHECK FOR EXACTLY THREE PARAMETERS
+  LDA ACERGC+1
   BNE COPYSAGERROR
   SEC
   LDA ACERGC
   SBC BASERG
   CMP #2
   BNE COPYSAGERROR
   ;** GET BUFFER PARAMETERS
   LDA BASERG
   LDY #0
   JSR GETARG
   LDA ZP
   LDY ZP+1
   STA COPYNAME
   STY COPYNAME+1
   INC BASERG
   LDA BASERG
   LDY #0
   JSR GETARG
   LDA ZP
   LDY ZP+1
   STA COPYUTAME
   STY COPYUTAME+1
   JSR COPYFILE
   RTS

COPYSAGERROR = *
   LDA #<COPYSAGERRORSG
   LDY #>COPYSAGERRORSG
   LDX #STDERR
   JSR FPUTS
   RTS
   COPYSAGERRORSG = *
   .ASC "USAGE: CP FROMFILE TOFILE"
   .BYTE CHR
   .ASC "       CP FROMFILE1 FROM2 ...FROM TODIR"
   .BYTE CHR,0

COPYFILE = *
   ;** OPEN FILES
   LDA COPYNAME
   LDY COPYNAME+1
   STA ZP
   STY ZP+1
   LDA #"R"
   JSR OPEN
   BCC +
   LDA COPYNAME
   LDY COPYNAME+1
   JMP COPYPENRROR
+  STA COPYNILE
COPYFILEUTPUT = *
   LDA COPYUTAME
   LDY COPYUTAME+1
   STA ZP
   STY ZP+1
   LDA #"W"
   JSR OPEN
   BCC COPYRITEK
   LDA ERRNO
   CMP #ACERRILEXISTS
   BEQ +
-  LDA COPYNILE
   JSR CLOSE
   LDA COPYUTAME
   LDY COPYUTAME+1
   JMP COPYPENRROR
+  JSR COPYSKVERWRITE
   BEQ +
   LDA COPYNILE
   JSR CLOSE
   SEC
   RTS
+  JSR COPYEMOVEUTFILE
   JMP COPYFILEUTPUT

   COPYRITEK = *
   STA COPYUTILE
   JSR COPYILEONTENTS
   LDA COPYUTILE
   JSR CLOSE
   LDA COPYNILE
   JSR CLOSE
   RTS

COPYSKVERWRITE = *  ;() : .=QUIT, .=YES, .=NO
   LDA OVERWRITELLLAG
   BEQ +
   LDA #0
   RTS
/  LDA #<COPYSKVERWRITESG
   LDY #>COPYSKVERWRITESG
   JSR PUTS
   LDA COPYUTAME
   LDY COPYUTAME+1
   JSR PUTS
   LDA #<COPYSKVERWRITESG2
   LDY #>COPYSKVERWRITESG2
   JSR PUTS
   JSR GETCHAR
   CMP #CHR
   BEQ -
   PHA
-  JSR GETCHAR
   CMP #CHR
   BNE -
   PLA
   CMP #"Q"
   BNE +
-  LDA #$FF
   STA ABORTLAG
   SEC
   RTS
+  CMP #""
   BEQ -
   CMP #"A"
   BNE +
-  LDA #$FF
   STA OVERWRITELLLAG
   LDA #"Y"
+  CMP #""
   BEQ -
   CMP #"Y"
   BEQ +
   CMP #""
+  CLC
   RTS
   COPYSKVERWRITESG = *
   .ASC "VERWRITE "
   .BYTE CHRUOTE,0
   COPYSKVERWRITESG2 = *
   .BYTE CHRUOTE
   .ASC " (Y/N/A/Q)? "
   .BYTE 0

COPYEMOVEUTFILE = *
   LDA COPYUTAME
   LDY COPYUTAME+1
   STA ZP
   STY ZP+1
   JSR REMOVE
   RTS

COPYILEONTENTS = *
   ;** COPY FILE CONTENTS
   LDA COPYUFFERTR
   LDY COPYUFFERTR+1
   STA ZP
   STY ZP+1
-  JSR CHECKSTOP
   LDA COPYUFFERENGTH
   LDY COPYUFFERENGTH+1
   LDX COPYNILE
   JSR READ
   BCS ++
   BEQ +
   PHA
   TYA
   PHA
   JSR CHECKSTOP
   PLA
   TAY
   PLA
   LDX COPYUTILE
   JSR WRITE
   BCC -
   BCS COPYILERROR
+  RTS
+  JMP COPYILERROR
   
   COPYPENAME = 14
CPRRNO = $50
CPUMBUF .BUF 12
   COPYPENRROR = *
   LDX ERRNO
   STX CPRRNO+0
   STA COPYPENAME
   STY COPYPENAME+1
   LDA #<COPYPENRRORSG1
   LDY #>COPYPENRRORSG1
   LDX #STDERR
   JSR FPUTS
   LDA COPYPENAME
   LDY COPYPENAME+1
   LDX #STDERR
   JSR FPUTS
   LDA #<COPYPENRRORSG2
   LDY #>COPYPENRRORSG2
   LDX #STDERR
   JSR FPUTS
   LDA #0
   STA CPRRNO+1
   STA CPRRNO+2
   STA CPRRNO+3
   LDA #<CPUMBUF
   LDY #>CPUMBUF
   STA ZP+0
   STY ZP+1
   LDX #CPRRNO
   LDA #1
   JSR UTOA
   LDA #<CPUMBUF
   LDY #>CPUMBUF
   LDX #STDERR
   JSR FPUTS
   LDA #<COPYPENRRORSG3
   LDY #>COPYPENRRORSG3
   LDX #STDERR
   JSR FPUTS
   RTS

   COPYPENRRORSG1 = *
   .ASC "RROR OPENING FILE "
   .BYTE CHRUOTE
   .BYTE 0
   COPYPENRRORSG2 = *
   .BYTE CHRUOTE
   .ASC ", CODE "
   .BYTE 0
   COPYPENRRORSG3 = *
   .BYTE CHR
   .BYTE 0

   COPYILERROR = *
   LDA #<COPYILERRORSG
   LDY #>COPYILERRORSG
   LDX #STDERR
   JMP FPUTS
   COPYILERRORSG = *
   .ASC "ILE DATA ERROR!"
   .BYTE CHR
   .BYTE 0

COPYRG = 12
LASTRG = 14
COPYOIR = *
   LDA BASERG
   LDY #0
   STA COPYRG
   STY COPYRG+1
-  LDA ACERGC
   LDY ACERGC+1
   SEC
   SBC #1
   BCS +
   DEY
+  CMP COPYRG
   BNE +
   CPY COPYRG+1
   BEQ COPYOIRXIT
+  JSR CHECKSTOP
   LDA COPYRG
   LDY COPYRG+1
   JSR GETARG
   LDA ZP
   LDY ZP+1
   STA COPYNAME
   STY COPYNAME+1
   JSR COPYILEOIR
   LDA ABORTLAG
   BNE COPYOIRTOPPED
   INC COPYRG
   BNE +
   INC COPYRG+1
+  JMP -

COPYOIRXIT = *
   RTS

CHECKSTOP = *
   JSR STOPKEY
   BCS +
   RTS
COPYOIRTOPPED = *
+  LDA #<STOPPEDSG
   LDY #>STOPPEDSG
   JSR EPUTS
   LDA #1
   LDX #0
   JMP EXIT

   STOPPEDSG = *
   .ASC "<TOPPED>"
   .BYTE CHR,0

SCANOS = 6

COPYILEOIR = *
   ;** GENERATE OUTPUT FILE NAME
   JSR GETASTRG
   LDY #0
-  LDA (ZP),Y
   BEQ +
   STA COPYAMEUF,Y
   INY
   BNE -
+  TYA
   TAX
   ;** EXTRACT BASENAME
   LDY #0
   STY SCANOS
-  LDA (COPYNAME),Y
   BEQ +
   CMP #":"
   BNE BASENAMEEXT
   INY
   STY SCANOS
   DEY
   BASENAMEEXT = *
   INY
   BNE -

+  LDY SCANOS
-  LDA (COPYNAME),Y
   STA COPYAMEUF,X
   BEQ +
   INX
   INY
   BNE -
   ;** COPY FILE
+  LDA #<COPYAMEUF
   LDY #>COPYAMEUF
   STA COPYUTAME
   STY COPYUTAME+1
   JSR COPYOIRTATUS
   JSR COPYFILE
   RTS

NAMEPACE .BUF 1

COPYOIRTATUS = *
   LDA COPYNAME
   LDY COPYNAME+1
   JSR PUTS

   LDY #255
-  INY
   LDA (COPYNAME),Y
   BNE -
   TYA
-  SEC
   SBC #10
   BCS -
   ADC #10
   STA NAMEPACE
   STA NAMEPACE
   SEC
   LDA #10
   SBC NAMEPACE
   STA NAMEPACE

-  LDA #" "
   JSR PUTCHAR
   DEC NAMEPACE
   BNE -

   LDA COPYUTAME
   LDY COPYUTAME+1
   JSR PUTS
   LDA #CHR
   JSR PUTCHAR
   RTS

;===THE END===
CPSS = *
COPYAMEUF = CPSS+0
CPND = CPSS+256
