;*** MV (RENAME) PROGRAM

.SEQ ACEHEAD.S
.ORG ACEPPDDRESS
.OBJ "@0:MV"

JMP MAIN
.BYTE ACE1,ACE2,ACE3
.BYTE 64,0  ;** STACK,RESERVED

;*** GLOBAL DECLARATIONS

CHR = $0D
CHRUOTE = $22

;******** STANDARD LIBRARY ********
PUTS = *
   LDX #STDOUT
FPUTS = *
   STA ZP+0
   STY ZP+1
   LDY #$FF
-  INY
   LDA (ZP),Y
   BNE -
   TYA
   LDY #0
   JMP WRITE
EPUTS = *
   LDX #STDERR
   JMP FPUTS

PUTCHAR = *
   LDX #STDOUT
PUTC = *
   STA PUTCUFFER
   LDA #<PUTCUFFER
   LDY #>PUTCUFFER
   STA ZP+0
   STY ZP+1
   LDA #1
   LDY #0
   JMP WRITE
   PUTCUFFER .BUF 1

GETCHAR = *
   LDX #STDIN
GETC = *
   LDA #<GETCUFFER
   LDY #>GETCUFFER
   STA ZP+0
   STY ZP+1
   LDA #1
   LDY #0
   JSR READ
   BEQ +
   LDA GETCUFFER
   RTS
+  SEC
   RTS
   GETCUFFER .BUF 1

GETARG = *
   STY ZP+1
   ASL
   STA ZP+0
   ROL ZP+1
   CLC
   LDA ACERGV
   ADC ZP+0
   STA ZP+0
   LDA ACERGV+1
   ADC ZP+1
   STA ZP+1
   LDY #0
   LDA (ZP),Y
   TAX
   INY
   LDA (ZP),Y
   STX ZP+0
   STA ZP+1
   RTS

;===RENAME===

ARG = 2
OLDNAME = 4
NEWNAME = 6

MAIN = *
   ;** CHECK ARGUMENT COUNT
   LDA ACERGC+1
   BNE ENOUGHRGS
   LDA ACERGC+0
   CMP #3
   BCS ENOUGHRGS

USAGE = *
   LDA #<USAGESG
   LDY #>USAGESG
   JMP PUTS

USAGESG = *
   .ASC "SAGE: MV OLDNAME NEWNAME ..."
   .BYTE CHR
   .ASC "       WHERE ... MEANS REPEAT NAMES IN OLD/NEW PAIRS"
   .BYTE CHR,0

ENOUGHRGS = *
   LDA #1
   LDY #0
   STA ARG+0
   STY ARG+1

   MAINEXT = *
   LDA ARG+0
   LDY ARG+1
   JSR GETARG
   LDA ZP+0
   LDY ZP+1
   STA OLDNAME+0
   STY OLDNAME+1
   ORA ZP+1
   BEQ MAINXIT
   INC ARG+0
   BNE +
   INC ARG+1
+  LDA ARG+0
   LDY ARG+1
   JSR GETARG
   LDA ZP+0
   LDY ZP+1
   STA NEWNAME+0
   STY NEWNAME+1
   ORA ZP+1
   BEQ MAINXIT

   JSR CHECKSTOP
   JSR ECHO
   LDA OLDNAME+0
   LDY OLDNAME+1
   STA ZP+0
   STY ZP+1
   LDA NEWNAME+0
   LDY NEWNAME+1
   STA ZW+0
   STY ZW+1
   JSR RENAME
   BCC +
   JSR ERROR
+  INC ARG+0
   BNE +
   INC ARG+1
+  JMP MAINEXT

MAINXIT = *
   RTS

CHECKSTOP = *
   JSR STOPKEY
   BCS +
   RTS
+  LDA #<STOPPEDSG
   LDY #>STOPPEDSG
   JSR EPUTS
   LDA #1
   LDX #0
   JMP EXIT

   STOPPEDSG = *
   .ASC "<STOPPED>"
   .BYTE CHR,0

ERROR = *
   LDA #<ERRORSG1
   LDY #>ERRORSG1
   JSR EPUTS
   LDA OLDNAME+0
   LDY OLDNAME+1
   JSR EPUTS
   LDA #<ERRORSG2
   LDY #>ERRORSG2
   JMP EPUTS

ERRORSG1 = *
   .ASC "RROR ATTEMPTING TO RENAME "
   .BYTE CHRUOTE,0

ERRORSG2 = *
   .BYTE CHRUOTE,CHR,0

ECHO = *
   LDA #<ECHOSG1
   LDY #>ECHOSG1
   JSR EPUTS
   LDA OLDNAME+0
   LDY OLDNAME+1
   JSR EPUTS
   LDA #<ECHOSG2
   LDY #>ECHOSG2
   JSR EPUTS
   LDA NEWNAME+0
   LDY NEWNAME+1
   JSR EPUTS
   LDA #<ECHOSG3
   LDY #>ECHOSG3
   JSR EPUTS
   RTS   

ECHOSG1 = *
   .ASC "ENAMING FILE "
   .BYTE CHRUOTE,0

ECHOSG2 = *
   .BYTE CHRUOTE
   .ASC " TO "
   .BYTE CHRUOTE,0

ECHOSG3 = *
   .BYTE CHRUOTE,CHR,0

;===THE END===
BSS    = *
BSSND = BSS+0
