;*** UUDECODE PROGRAM

.SEQ ACEHEAD.S
.ORG ACEPPDDRESS
.OBJ "@0:UUDECODE"

JMP UUDECODEAIN
.BYTE ACE1,ACE2,ACE3
.BYTE 64,0  ;** STACK,RESERVED

;*** GLOBAL DECLARATIONS

LIBWORK = $60

CHR = $0A
CHR = $0D
CHRUOTE = $22

ASCIIILE .BUF 1
TEMP .BUF 1

;******** STANDARD LIBRARY ********
PUTS = *
   LDX #STDOUT
FPUTS = *
   STA ZP
   STY ZP+1
   LDY #$FF
-  INY
   LDA (ZP),Y
   BNE -
   TYA
   LDY #0
   JMP WRITE
EPUTS = *
   LDX #STDERR
   JMP FPUTS

PUTCHAR = *
   LDX #STDOUT
PUTC = *
   STA PUTCUFFER
   LDA #<PUTCUFFER
   LDY #>PUTCUFFER
   STA ZP
   STY ZP+1
   LDA #1
   LDY #0
   JMP WRITE
   PUTCUFFER .BUF 1

GETCHAR = *
   LDX #STDIN
GETC = *
   LDA #<GETCUFFER
   LDY #>GETCUFFER
   STA ZP
   STY ZP+1
   LDA #1
   LDY #0
   JSR READ
   BEQ +
   LDA GETCUFFER
   RTS
+  SEC
   RTS
   GETCUFFER .BUF 1

GETARG = *
   STY ZP+1
   ASL
   STA ZP
   ROL ZP+1
   CLC
   LDA ACERGV
   ADC ZP
   STA ZP
   LDA ACERGV+1
   ADC ZP+1
   STA ZP+1
   LDY #0
   LDA (ZP),Y
   TAX
   INY
   LDA (ZP),Y
   STX ZP
   STA ZP+1
   RTS

CHECKSTOP = *
   JSR STOPKEY
   BCS +
   RTS
+  LDA #<STOPPEDSG
   LDY #>STOPPEDSG
   JSR EPUTS
   LDA #1
   LDX #0
   JMP EXIT
   STOPPEDSG = *
   .ASC "<TOPPED>"
   .BYTE CHR,0

;===UUDECODE===
UUDRG = 2
UUDAME = 4
INUFEN = 6

UUDECODEAIN = *
   ;** CHECK ARGUMENT COUNT
   LDA ACERGC+1
   BNE UUDNOUGHRGS
   LDA ACERGC
   CMP #2
   BCS UUDNOUGHRGS

UUDSAGE = *
   LDA #<UUDSAGESG
   LDY #>UUDSAGESG
   JMP PUTS

UUDSAGESG = *
   .ASC "SAGE: UUDECODE FILE1 FILE2 ... FILE"
   .BYTE CHR,0

UUDNOUGHRGS = *
   ;** GET INPUT BUFFER LENGTH
   SEC
   LDA ACEEMOP+0
   SBC #<UUDNUF
   STA INUFEN
   LDA ACEEMOP+1
   SBC #>UUDNUF
   STA INUFEN+1
   ;** MAIN LOOP
   LDA #1
   LDY #0
   STA UUDRG
   STY UUDRG+1
-  JSR CHECKSTOP
   LDA UUDRG
   LDY UUDRG+1
   JSR GETARG
   LDA ZP
   LDY ZP+1
   STA UUDAME
   STY UUDAME+1
   ORA ZP+1
   BEQ UUDXIT
   JSR UUDCHO
   JSR UUDECODE
   BCC +
   JSR UUDRROR
+  INC UUDRG
   BNE +
   INC UUDRG+1
+  JMP -

UUDXIT = *
   RTS

UUDRROR = *
   LDA #<UUDRRORSG1
   LDY #>UUDRRORSG1
   JSR EPUTS
   LDA UUDAME
   LDY UUDAME+1
   JSR EPUTS
   LDA #<UUDRRORSG2
   LDY #>UUDRRORSG2
   JMP EPUTS

UUDRRORSG1 = *
   .ASC "RROR ATTEMPTING TO UUDECODE FILE "
   .BYTE CHRUOTE,0
UUDRRORSG2 = *
   .BYTE CHRUOTE,CHR,0

UUDCHO = *
   LDA #<UUDCHOSG1
   LDY #>UUDCHOSG1
   JSR EPUTS
   LDA UUDAME
   LDY UUDAME+1
   JSR EPUTS
   LDA #<UUDCHOSG2
   LDY #>UUDCHOSG2
   JMP EPUTS

UUDCHOSG1 = *
   .ASC "UUDECODING FILE "
   .BYTE CHRUOTE,0

UUDCHOSG2 = *
   .BYTE CHRUOTE
   .ASC "..."
   .BYTE CHR,0

BUFTR = 8
BUFOUNT = 10
INFILE = 12
OUTFILE = 13

UUDECODE = *
   ;** OPEN FILE
   LDA UUDAME
   LDY UUDAME+1
   STA ZP
   STY ZP+1
   LDA #"R"
   JSR OPEN
   BCC +
   RTS
+  STA INFILE
   ;** DECODE FILE
   JSR UUDECODEODY
   ;** CLOSE FILE
   LDA INFILE
   JSR CLOSE
   RTS

UUDECODEODY = *
   LDA #0
   STA BUFOUNT
   STA BUFOUNT+1
   STA HITASTINE
   STA LASTINEERMINATOR

   ;** SEARCH FOR "BEGIN" LINE
   UUDEARCHINE = *
   JSR GETLINE
   BCC +
   RTS
+  LDX #0
   LDA UUDNINE
   CMP #"B"
   BEQ +
   LDX #ASCIIEGIN-PETSCIIEGIN
+  LDY #0
-  LDA UUDNINE,Y
   CMP PETSCIIEGIN,X
   BNE UUDEARCHINE
   INX
   INY
   CPY #6
   BCC -
   LDY #0
   CPX #ASCIIEGIN-PETSCIIEGIN+1
   BCC +
   LDY #$FF
+  STY ASCIIILE
   LDA UUDNINE+9
   CMP #" "
   BNE UUDEARCHINE
   LDX #0
-  LDA UUDNINE+6,X
   CMP #"0"
   BCC UUDEARCHINE
   CMP #"8"
   BCS UUDEARCHINE
   INX
   CPX #3
   BCC -
   JMP PROCESSEGIN

   PETSCIIEGIN = *
   .ASC "BEGIN "
   ASCIIEGIN = *
   .BYTE $62,$65,$67,$69,$6E,$20
   
   ;** PROCESS "BEGIN" LINE
   PROCESSEGIN = *
   LDA ASCIIILE
   BEQ +
   ;** JSR CONVERT FILENAME
+  JSR MAKEETSCIIAME
   JSR DEFAULTRGILE
   JSR ECHOXTRACTAME
   LDA #<UUDNINE+10
   LDY #>UUDNINE+10
   STA ZP
   STY ZP+1
   LDA #"W"
   JSR OPEN
   BCC OPENK
   LDA ERRNO
   CMP #ACERRILEXISTS
   BEQ +
-  JSR REPORTPENRROR
   JMP UUDEARCHINE
+  JSR SCRATCHILE
   LDA #"W"
   JSR OPEN
   BCS -

   OPENK = *
   STA OUTFILE
 
   ;** READ UUENCODED DATA
-  JSR GETLINE
   BCS UUDINISHILE
   JSR UUONVERTINE
   BCC +
   ;** REPORT INVALID CHARACTERS
   LDA #<BADHARSSG
   LDY #>BADHARSSG
   JSR EPUTS
   JMP -
+  LDA UUDNINE
   BEQ UUDINISHILE
   JSR UURUNCHINE
   JSR UURITEINE
   JMP -

   ;** FINISH WITH FILE
   UUDINISHILE = *
   LDA OUTFILE
   JSR CLOSE
   ;** PROCESS FOR ANOTHER FILE
   JMP UUDEARCHINE

BADHARSSG = *
   .ASC "WARNING: BAD CHARACTERS IN LINE; IGNORING LINE."
   .BYTE CHR,0

;%%%
MAKEETSCIIAME = *
   BIT ASCIIILE
   BMI +
   RTS
+  LDX #0
-  LDA UUDNINE+10,X
   BEQ +
   JSR CONVSC2ET
   STA UUDNINE+10,X
   INX
   BNE -
+  RTS

CONVSC2ET = *
   AND #$7F
   CMP #$60
   BCC +
   CLC
   ADC #$C0-$60
+  TAY
   AND #$7F
   CMP #"A"
   BCS +
-  TYA
   RTS
+  CMP #"Z"+1
   BCS -
   TYA
   EOR #$80
   RTS

DEFAULTRGILE = *
   LDX #0
-  LDA UUDNINE+10,X
   BEQ +
   INX
   BNE -
+  LDA UUDNINE+8,X
   CMP #","
   BNE +
   RTS
+  LDA #","
   STA UUDNINE+10,X
   LDA #"P"
   STA UUDNINE+11,X
   LDA #0
   STA UUDNINE+12,X
   RTS

ECHOXTRACTAME = *
   LDA #<ECHOXTRACTSG1
   LDY #>ECHOXTRACTSG1
   JSR EPUTS
   LDA #<UUDNINE+10
   LDY #>UUDNINE+10
   JSR EPUTS
   LDA #<ECHOXTRACTSG2
   LDY #>ECHOXTRACTSG2
   JMP EPUTS

ECHOXTRACTSG1 = *
   .ASC "EXTRACTING FILE "
   .BYTE CHRUOTE,0

ECHOXTRACTSG2 = *
   .BYTE CHRUOTE
   .ASC "..."
   .BYTE CHR,0

REPORTPENRROR = *
   LDA ZP
   LDY ZP+1
   JSR EPUTS
   LDA #<REPORTPENRRORSG
   LDY #>REPORTPENRRORSG
   JSR EPUTS
   RTS

   REPORTPENRRORSG = *
   .ASC ": CANNOT OPEN; SKIPPING THIS FILE."
   .BYTE CHR,0

SCRATCHILE = *
   LDA #<SCRATCHILESG1
   LDY #>SCRATCHILESG1
   JSR EPUTS
   LDA #<UUDNINE+10
   LDY #>UUDNINE+10
   JSR EPUTS
   LDA #<SCRATCHILESG2
   LDY #>SCRATCHILESG2
   JSR EPUTS
   JSR GETCHAR
   PHA
-  CMP #CHR
   BEQ +
   JSR GETCHAR
   JMP -
+  LDA #<UUDNINE+10
   LDY #>UUDNINE+10
   STA ZP
   STY ZP+1
   PLA
   CMP #"Y"
   BEQ +
   CMP #""
   BEQ +
   RTS
+  JSR REMOVE
   RTS

   SCRATCHILESG1 = *
   .ASC "VERWRITE EXISTING FILE "
   .BYTE CHRUOTE,0
   SCRATCHILESG2 = *
   .BYTE CHRUOTE
   .ASC "? "
   .BYTE 0

CONVERTILL .BUF 1
CONVERTEN = 15
UUONVERTINE = *
   LDA #0
   STA CONVERTILL
   LDA UUDNINE
   BNE +
   CLC
   RTS
+  JSR UUONVERTHAR
   BCC +
   RTS
+  STA UUDNINE
   LDX #60
   CMP #46
   BCC +
   LDX #84
+  STX CONVERTEN
   LDX #0
-  CPX CONVERTEN
   BCC +
   CLC
   RTS
+  BIT CONVERTILL
   BMI DOONVERTILL
   LDA UUDNINE+1,X
   BEQ +
   JSR UUONVERTHAR
   BCC CONVERTONT
   RTS
+  LDA #$FF
   STA CONVERTILL

   DOONVERTILL = *
   LDA #0

   CONVERTONT = *
   STA UUDNINE+1,X
   INX
   BNE -
   RTS

UUONVERTHAR = *
   CMP #" "
   BCS +
   SEC
   RTS
+  CMP #"_"+1
   BCS +
   SEC
   SBC #" "
   CLC
   RTS
+  CMP #96
   BNE +
-  CLC
   LDA #0
   RTS
+  CMP #""
   BEQ -
   BCS +
   SEC
   RTS
+  CMP #""+1
   BCC +
   RTS
+  SEC
   SBC #""-33
   CLC
   RTS

UURUNCHINE = *
   LDX #0
   LDY #0
-  JSR UURUNCHROUP
   CPY UUDNINE
   BCC -
   RTS

;POS  76543210  76543210  76543210  76543210
;BYT  XX111111  XX112222  XX222233  XX333333
;BIT    765432    107654    321076    543210

UURUNCHROUP = * ;(.=N4BYTESFFSET, .=UT3BYTESFFSET) : .++, .++
   LDA UUDNINE+1,X  ;*** OUTPUT BYTE 0
   ASL
   ASL
   STA TEMP
   INX
   LDA UUDNINE+1,X
   LSR
   LSR
   LSR
   LSR
   AND #%00000011
   ORA TEMP
   STA UUDNINE+1,Y
   INY
   LDA UUDNINE+1,X  ;*** OUTPUT BYTE 1
   ASL
   ASL
   ASL
   ASL
   STA TEMP
   INX
   LDA UUDNINE+1,X
   LSR
   LSR
   AND #%00001111
   ORA TEMP
   STA UUDNINE+1,Y
   INY
   LDA UUDNINE+1,X  ;*** OUTPUT BYTE 2
   INX
   ROR
   ROR
   ROR
   AND #%11000000
   STA TEMP
   LDA UUDNINE+1,X
   INX
   AND #%00111111
   ORA TEMP
   STA UUDNINE+1,Y
   INY
   RTS

UURITEINE = *
   LDA #<UUDNINE+1
   LDY #>UUDNINE+1
   STA ZP
   STY ZP+1
   LDA UUDNINE
   LDY #0
   LDX OUTFILE
   JSR WRITE
   RTS

GETLINEOS = 14
HITASTINE .BUF 1
LASTINEERMINATOR .BUF 1

GETLINE = *
   LDA HITASTINE
   BEQ +
   SEC
   RTS
+  LDX #0
   STX GETLINEOS

   ;** TOSS AN  THAT FOLLOWS A 
   JSR GETYTE
   BCS GETLINEROCESS
   CMP #CHR
   CLC
   BNE GETLINEROCESS
   LDX LASTINEERMINATOR
   CPX #CHR
   CLC
   BNE GETLINEROCESS

   GETLINEHAR = *
   JSR GETYTE
   GETLINEROCESS = *
   BCC +
   LDA #$FF
   STA HITASTINE
   JMP GETLINEINISH
+  CMP #CHR
   BEQ GETLINEINISH
   CMP #CHR
   BEQ GETLINEINISH
   LDX GETLINEOS
   CPX #98
   BCS +
   STA UUDNINE,X
   INC GETLINEOS
+  JMP GETLINEHAR

   GETLINEINISH = *
   STA LASTINEERMINATOR
   LDX GETLINEOS
   LDA #0
   STA UUDNINE,X
   CPX #0
   BEQ +
   CLC
   RTS
+  LDA HITASTINE
   CMP #1
   RTS

GETYTE = *
   LDA BUFOUNT
   ORA BUFOUNT+1
   BEQ GETYTEILLUF
   LDY #0
   LDA (BUFTR),Y
   INC BUFTR
   BNE +
   INC BUFTR+1
+  LDX BUFOUNT
   BNE +
   DEC BUFOUNT+1
+  DEC BUFOUNT
   CLC
   RTS

GETYTEILLUF = *
   JSR CHECKSTOP
   LDA #<UUDNUF
   LDY #>UUDNUF
   STA ZP
   STY ZP+1
   STA BUFTR
   STY BUFTR+1
   LDA INUFEN
   LDY INUFEN+1
   LDX INFILE
   JSR READ
   BEQ +
   BCS +
   STA BUFOUNT
   STY BUFOUNT+1
   JMP GETYTE
+  SEC
   RTS

;===THE END===
UUDSS = *
UUDNINE = UUDSS+0
UUDNUF  = UUDSS+100
