;*** UUENCODE PROGRAM

.SEQ ACEHEAD.S
.ORG ACEPPDDRESS
.OBJ "@0:UUENCODE"

JMP UUENCODEAIN
.BYTE ACE1,ACE2,ACE3
.BYTE 64,0  ;** STACK,RESERVED

;*** GLOBAL DECLARATIONS

LIBWORK = $60

CHR = $0D
CHRUOTE = $22

;******** STANDARD LIBRARY ********
PUTS = *
   LDX #STDOUT
FPUTS = *
   STA ZP
   STY ZP+1
   LDY #$FF
-  INY
   LDA (ZP),Y
   BNE -
   TYA
   LDY #0
   JMP WRITE
EPUTS = *
   LDX #STDERR
   JMP FPUTS

PUTCHAR = *
   LDX #STDOUT
PUTC = *
   STA PUTCUFFER
   LDA #<PUTCUFFER
   LDY #>PUTCUFFER
   STA ZP
   STY ZP+1
   LDA #1
   LDY #0
   JMP WRITE
   PUTCUFFER .BUF 1

GETCHAR = *
   LDX #STDIN
GETC = *
   LDA #<GETCUFFER
   LDY #>GETCUFFER
   STA ZP
   STY ZP+1
   LDA #1
   LDY #0
   JSR READ
   BEQ +
   LDA GETCUFFER
   RTS
+  SEC
   RTS
   GETCUFFER .BUF 1

GETARG = *
   STY ZP+1
   ASL
   STA ZP
   ROL ZP+1
   CLC
   LDA ACERGV
   ADC ZP
   STA ZP
   LDA ACERGV+1
   ADC ZP+1
   STA ZP+1
   LDY #0
   LDA (ZP),Y
   TAX
   INY
   LDA (ZP),Y
   STX ZP
   STA ZP+1
   RTS

BASENAMETART = LIBWORK

BASENAME = * ;( (ZP)=INNAME ) : UUEUTUF=OUTNAME
   LDY #255
   STY BASENAMETART
-  INY
   LDA (ZP),Y
   BEQ BASENAMEONE
   CMP #":"
   BEQ +
   CMP #"/"
   BNE -
+  STY BASENAMETART
   JMP -
   BASENAMEONE = *
   LDY BASENAMETART
   LDX #255
-  INY
   INX
   LDA (ZP),Y
   STA UUEUTUF,X
   BNE -
   CPX #2
   BCC +
   LDA UUEUTUF-2,X
   CMP #","
   BNE +
   LDA #0
   STA UUEUTUF-2,X
+  RTS

;===UUENCODE===
UUERG = 2
UUEAME = 4
INUFEN = 6

UUENCODEAIN = *
   ;** CHECK ARGUMENT COUNT
   LDA ACERGC+1
   BNE UUENOUGHRGS
   LDA ACERGC
   CMP #2
   BCS UUENOUGHRGS

UUESAGE = *
   LDA #<UUESAGESG
   LDY #>UUESAGESG
   JMP PUTS

UUESAGESG = *
   .ASC "SAGE: UUENCODE FILE1 FILE2 ... FILE"
   .BYTE CHR
   .BYTE 0

UUENOUGHRGS = *
   ;** GET INPUT BUFFER LENGTH
   SEC
   LDA ACEEMOP+0
   SBC #<UUENUF
   STA INUFEN
   LDA ACEEMOP+1
   SBC #>UUENUF
   STA INUFEN+1
   ;** MAIN LOOP
   LDA #1
   LDY #0
   STA UUERG
   STY UUERG+1
-  JSR CHECKSTOP
   LDA UUERG
   LDY UUERG+1
   JSR GETARG
   LDA ZP
   LDY ZP+1
   STA UUEAME
   STY UUEAME+1
   ORA ZP+1
   BEQ UUEXIT
   JSR UUECHO
   JSR UUENCODE
   BCC +
   JSR UUERROR
+  INC UUERG
   BNE +
   INC UUERG+1
+  JMP -

UUEXIT = *
   RTS

UUERROR = *
   LDA #<UUERRORSG1
   LDY #>UUERRORSG1
   JSR EPUTS
   LDA UUEAME
   LDY UUEAME+1
   JSR EPUTS
   LDA #<UUERRORSG2
   LDY #>UUERRORSG2
   JMP EPUTS

UUERRORSG1 = *
   .ASC "RROR ATTEMPTING TO UUENCODE "
   .BYTE CHRUOTE
   .BYTE 0

UUERRORSG2 = *
   .BYTE CHRUOTE
   .BYTE CHR
   .BYTE 0

UUECHO = *
   LDA #<UUECHOSG1
   LDY #>UUECHOSG1
   JSR EPUTS
   LDA UUEAME
   LDY UUEAME+1
   JSR EPUTS
   LDA #<UUECHOSG2
   LDY #>UUECHOSG2
   JMP EPUTS

UUECHOSG1 = *
   .ASC "UENCODING FILE "
   .BYTE CHRUOTE
   .BYTE 0

UUECHOSG2 = *
   .BYTE CHRUOTE
   .ASC "..."
   .BYTE CHR
   .BYTE 0

CHECKSTOP = *
   JSR STOPKEY
   BCS +
   RTS
+  LDA #<STOPPEDSG
   LDY #>STOPPEDSG
   JSR EPUTS
   LDA #1
   LDX #0
   JMP EXIT

   STOPPEDSG = *
   .ASC "<TOPPED>"
   .BYTE CHR,0

BUFTR = 8
BUFOUNT = 10
INFILE = 12

UUENCODE = *
   ;** OPEN FILE
   LDA UUEAME
   LDY UUEAME+1
   STA ZP
   STY ZP+1
   LDA #"R"
   JSR OPEN
   BCC +
   RTS
+  STA INFILE
   ;** ENCODE FILE
   JSR UUENCODEODY
   ;** CLOSE FILE
   LDA INFILE
   JSR CLOSE
   RTS

UUENCODEODY = *
   LDA #0
   STA BUFOUNT
   STA BUFOUNT+1
   ;** HEADER LINE
   LDA #<UUEEADERSG
   LDY #>UUEEADERSG
   JSR PUTS
   LDA UUEAME
   LDY UUEAME+1
   STA ZP
   STY ZP+1
   JSR BASENAME
   LDA #<UUEUTUF
   LDY #>UUEUTUF
   JSR PUTS
   LDA #CHR
   JSR PUTCHAR
   ;** LOOP
-  JSR UUINE
   BCC -
   ;** END LINE
   LDA #<UUENDSG
   LDY #>UUENDSG
   JSR PUTS
   ;** CRC LINE
   RTS

UUEEADERSG = *
   .ASC "BEGIN 640 "
   .BYTE 0

UUENDSG = *
   .ASC ""
   .BYTE CHR
   .ASC "END"
   .BYTE CHR,0

GETYTE = *
   LDA BUFOUNT
   ORA BUFOUNT+1
   BEQ GETYTEILLUF
   LDY #0
   LDA (BUFTR),Y
   INC BUFTR
   BNE +
   INC BUFTR+1
+  LDX BUFOUNT
   BNE +
   DEC BUFOUNT+1
+  DEC BUFOUNT
   CLC
   RTS

GETYTEILLUF = *
   JSR CHECKSTOP
   LDA #<UUENUF
   LDY #>UUENUF
   STA ZP
   STY ZP+1
   STA BUFTR
   STY BUFTR+1
   LDA INUFEN
   LDY INUFEN+1
   LDX INFILE
   JSR READ
   BEQ +
   BCS +
   STA BUFOUNT
   STY BUFOUNT+1
   JMP GETYTE
+  SEC
   RTS

DATALEN = 13
OUTLINELEN = 14

UUINE = *
   LDA #0
   STA DATALEN
   LDA #1
   STA OUTLINELEN
   ;** GET THE LINE
-  JSR GETOURHARS
   BCS +
   LDA DATALEN
   CMP #45
   BCC -
   CLC
   ;** PUT THE LINE
+  PHP
   LDY OUTLINELEN
   LDA #CHR
   STA UUEUTUF,Y
   INC OUTLINELEN
   LDA DATALEN
   CMP #0
   BEQ +
   JSR GETUCHAR
   STA UUEUTUF
   LDA #<UUEUTUF
   LDY #>UUEUTUF
   STA ZP
   STY ZP+1
   LDA OUTLINELEN
   LDY #0
   LDX #1
   JSR WRITE
+  PLP
   RTS

UUTEMP = 15
UUBUF .BUF 3

GETOURHARS = *
   LDX #2
   LDA #0
-  STA UUBUF,X
   DEX
   BPL -
   ;** READ THE BYTES
   LDX #0
-  STX UUTEMP
   JSR GETYTE
   BCS +
   LDX UUTEMP
   STA UUBUF,X
   INC DATALEN
   INX
   CPX #3
   BCC -
   CLC
   ;** PUT BYTES INTO OUTPUT LINE
;POS  76543210  76543210  76543210  76543210
;BYT  XX111111  XX112222  XX222233  XX333333
;BIT    765432    107654    321076    543210
+  PHP
   LDX UUTEMP
   CPX #0
   BNE +
   PLP
   RTS
+  LDY OUTLINELEN
   ;** FIRST BYTE
   LDA UUBUF
   LSR
   LSR
   JSR GETUCHAR
   STA UUEUTUF,Y
   INY

   ;** SECOND BYTE
   LDA UUBUF
   ASL
   ASL
   ASL
   ASL
   STA UUTEMP
   LDA UUBUF+1
   LSR
   LSR
   LSR
   LSR
   ORA UUTEMP
   JSR GETUCHAR
   STA UUEUTUF,Y
   INY

   ;** THIRD BYTE
   LDA UUBUF+1
   ASL
   ASL
   STA UUTEMP
   LDA UUBUF+2
   ASL
   ROL
   ROL
   AND #%00000011
   ORA UUTEMP
   JSR GETUCHAR
   STA UUEUTUF,Y
   INY

   ;** FOURTH BYTE
   LDA UUBUF+2
   JSR GETUCHAR
   STA UUEUTUF,Y
   INY
   STY OUTLINELEN
   PLP
   RTS

GETUCHAR = *
   AND #%00111111
   BNE +
   LDA #""
   RTS
+  CLC
   ADC #" "
   CMP #"A"
   BCS +
   RTS
+  CMP #"["
   BCS +
   ADC #128
+  RTS

;===THE END===
UUEND = *
UUEUTUF = UUEND
UUENUF = UUEUTUF+80
