;*** DIRECTORY PROGRAM - BY RAIG RUCE

.SEQ ACEHEAD.S
.ORG ACEPPDDRESS
.OBJ "@0:XLS"

JMP MAIN
.BYTE ACE1,ACE2,ACE3
.BYTE 64,0  ;** STACK,RESERVED

;*** GLOBAL DECLARATIONS

LIBWORK = 80

CHR = $0D
CHRLS = 147
CHRUOTE = $22
TRUE = $FF
FALSE = $00

ARG        = 2
NAME       = 4
STRING     = 8
DIRCB     = 16
DIROLUMNS = 17
DIRUROL  = 18
DIRONG    = 19
DIRPACES  = 20
DIRLINEEN = 21
DIRHOLS  = 22
DIRAGED   = 23
DIRHOWN   = 24
DIRLS     = 25
DIRILES   = 32
DIRYTES   = 36
DIRREE    = 40
WORK       = 64

MAIN = *
   LDA #FALSE
   STA DIRONG
   STA DIRAGED
   STA DIRHOWN
   STA DIRLS

   LDA #0
   LDY #0
   STA ARG+0
   STY ARG+1

   NEXTRG = *
   JSR STOPKEY
   BCC +
   JMP STOPPED
+  INC ARG+0
   BNE +
   INC ARG+1
+  LDA ARG+0
   LDY ARG+1
   JSR GETARG
   LDA ZP+0
   ORA ZP+1
   BEQ MAINXIT
   LDY #0
   LDA (ZP),Y
   CMP #"-"
   BNE NAMERG
   JSR HANDLEPTION
   JMP NEXTRG

   NAMERG = *
   LDA ZP+0
   LDY ZP+1
   STA NAME+0
   STY NAME+1
   JSR LS
   LDA #TRUE
   STA DIRHOWN
   JMP NEXTRG

MAINXIT = *
   LDA DIRHOWN
   BNE +
   LDA #<DEFAULTIR
   LDY #>DEFAULTIR
   STA NAME+0
   STY NAME+1
   JSR LS
+  RTS

   DEFAULTIR = *
   .BYTE ".",":",0

HANDLEPTION = *
   LDY #0
   STY WORK+2
   LDA ZP+0
   LDY ZP+1
   STA WORK+0
   STY WORK+1

   NEXTPTION = *
   INC WORK+2
   LDY WORK+2
   LDA (WORK),Y
   BNE +
   RTS
+  CMP #"?"
   BNE +
   LDA #<USAGESG
   LDY #>USAGESG
   JSR EPUTS
   LDA #0
   LDX #0
   JMP EXIT
+  CMP #"L"
   BNE +
   LDA #TRUE
   STA DIRONG
   JMP NEXTPTION
+  CMP #"C"
   BNE +
   LDA #TRUE
   STA DIRLS
   JMP NEXTPTION
+  JMP NEXTPTION

USAGESG = *
   .ASC "USAGE: LS [-][L][?][C] [DIRECTORY ...]"
   .BYTE CHR
   .ASC "OPTS:  L=LONG FORM, ?=HELP, C=CLEAR SCREEN"
   .BYTE CHR,0

STOPPED = *
   LDA #<STOPPEDSG
   LDY #>STOPPEDSG
   JSR EPUTS
   LDA #1
   LDX #0
   JMP EXIT
   STOPPEDSG = *
   .ASC "<TOPPED>"
   .BYTE CHR,0

ERROR = *
   LDA #<ERRORSG1
   LDY #>ERRORSG1
   JSR EPUTS
   LDA NAME+0
   LDY NAME+1
   JSR EPUTS
   LDA #<ERRORSG2
   LDY #>ERRORSG2
   JMP EPUTS

   ERRORSG1 = *
   .ASC "RROR READING DIRECTORY "
   .BYTE CHRUOTE,0
   ERRORSG2 = *
   .BYTE CHRUOTE,CHR,0

;===DIR===

LS = *
   LDA DIRLS
   BEQ +
   LDA #CHRLS
   JSR PUTCHAR
+  LDA DIRONG
   BNE DIR

TRUES = *
   LDX #1
   JSR DEVINFO
   STX DIRHOLS
   CMP #0
   BNE +
   TXA
   LDX #$FF
-  INX
   SBC #20
   BCS -
   TXA
   BNE LSETOLS

+  LDA #1
   LSETOLS = *
   STA DIROLUMNS
   JMP DIROMMON

DIR = *
   LDX #1
   JSR DEVINFO
   STX DIRHOLS
   LDA #1
   STA DIROLUMNS

DIROMMON = *
   LDA #0
   STA DIRUROL
   LDX #3
-  STA DIRYTES,X
   STA DIRILES,X
   DEX
   BPL -

   DIROTAME = *
   LDA NAME+0
   LDY NAME+1
   STA ZP+0
   STY ZP+1
   JSR DIROPEN
   BCC +
   JMP ERROR
+  STA DIRCB
   LDX DIRCB
   JSR DIRREAD
   BCS DIRXIT
   BEQ DIRXIT
   JSR STOPKEY
   BCC +
   JMP STOPPED
+  LDA DIRONG
   BPL DIREXT
   JSR DIRISPLAYEADING

   DIREXT = *
   LDX DIRCB 
   JSR DIRREAD
   BCS DIRXIT
   BEQ DIRXIT
   JSR STOPKEY
   BCC +
   JSR DIRXIT
   JMP STOPPED
+  LDA ACEIRENTAME+0
   BEQ DIRRAILERXIT
   LDA ACEIRENTSAGE
   AND #%00010000
   BNE DIREXT
   JSR DIRISPLAY
   JMP DIREXT

   DIRRAILERXIT = *
   LDA DIRONG
   BPL DIRXIT
   JSR DIRISPLAYRAILER
   JMP DIRXIT

   DIRXIT = *
   LDA DIRUROL
   BEQ +
   LDA #CHR
   JSR PUTCHAR
+  LDA DIRCB
   JMP DIRCLOSE

DIRISPLAY = *
   BIT ACEIRENTLAGS
   BMI ++
   INC DIRILES+0
   BNE +
   INC DIRILES+1
   BNE +
   INC DIRILES+2
   BNE +
   INC DIRILES+3
+  LDX #0
   LDY #4
   CLC
-  LDA DIRYTES,X
   ADC ACEIRENTYTES,X
   STA DIRYTES,X
   INX
   DEY
   BNE -
+  BIT DIRONG
   BMI +
   JMP DIRISPLAYHORT
+  JSR DIRETUPIRLINE
   LDA #<DIRLINE
   LDY #>DIRLINE
   STA ZP+0
   STY ZP+1
   LDA DIRLINEEN
   LDY #0
   LDX #STDOUT
   JMP WRITE

;*            000000000011111111112222222222333333333344444444445555555555
;*       POS: 012345678901234567890123456789012345678901234567890123456789
DIRLINE .ASC "DRWX*E-T  00-XX-00  12:00A 12345678 *  1234567890123456"
        .BYTE CHR,0
DIRLAGAMES .ASC "DRWX*E-T"
DIRATETR .ASC "  00-XX-00  12:00A "
DIRATEND = *

DIRETUPIRLINE = *
   ;** FLAGS
   LDX #0
   LDA ACEIRENTLAGS
-  ASL
   PHA
   LDA #"-"
   BCC +
   LDA DIRLAGAMES,X
+  STA DIRLINE+0,X
   PLA
   INX
   CPX #8
   BCC -

   ;** DATE
   JSR PUTNATE
   LDX #DIRATEND-DIRATETR-1
-  LDA DIRATETR,X
   STA DIRLINE+8,X
   DEX
   BPL -

   ;** BYTES
   LDX #3
-  LDA ACEIRENTYTES,X
   STA DIRREE,X
   DEX
   BPL -
   LDA #<UTOAUMBER
   LDY #>UTOAUMBER
   STA ZP+0
   STY ZP+1
   LDA #8
   LDX #DIRREE
   JSR UTOA
   LDY #28
   LDA DIRHOLS
   CMP #60
   BCS +
   LDY #8
+  LDX #0
-  LDA UTOAUMBER,X
   STA DIRLINE,Y
   INY
   INX
   CPX #8
   BCC -
   LDA #" "
   STA DIRLINE,Y
   INY

   ;** UNCLOSED FLAG
   LDA DIRLINE+4
   CMP #"-"
   BNE +
   LDA #" "
+  STA DIRLINE,Y
   INY

   ;** FILETYPE
   LDX #0
-  LDA ACEIRENTYPE,X
   ORA #$80
   STA DIRLINE,Y
   INY
   INX
   CPX #3
   BCC -
   LDA #" "
   STA DIRLINE,Y
   INY
   STA DIRLINE,Y
   INY

   ;** FILENAME
   LDX #0
-  LDA ACEIRENTAME,X
   BEQ +
   STA DIRLINE,Y
   INY
   INX
   BNE -
+  LDA #CHR
   STA DIRLINE,Y
   INY
   LDA #0
   STA DIRLINE,Y
   STY DIRLINEEN
   RTS

DIRISPLAYHORT = *
   LDA #<ACEIRENTAME
   LDY #>ACEIRENTAME
   JSR PUTS
   INC DIRUROL
   LDA DIRUROL
   CMP DIROLUMNS
   BCC +
   LDA #0
   STA DIRUROL
   LDA #CHR
   JMP PUTCHAR
+  LDY #$FF
-  INY
   LDA ACEIRENTAME,Y
   BNE -
   STY DIRPACES
   LDA #20
   SBC DIRPACES
   STA DIRPACES
-  LDA #" "
   JSR PUTCHAR
   DEC DIRPACES
   BNE -
   RTS

DIRISPLAYEADING = *
   LDA #<DIREADINGSG
   LDY #>DIREADINGSG
   JSR PUTS
   LDA #<ACEIRENTAME
   LDY #>ACEIRENTAME
   JSR PUTS
   LDA #CHR
   JSR PUTCHAR
   RTS

   DIREADINGSG = *
   .ASC "IR: "
   .BYTE 0

DIRISPLAYRAILER = *
   LDX #3
-  LDA ACEIRENTYTES,X
   STA DIRREE,X
   DEX
   BPL -
   LDX #0
   LDY #0
-  LDA DIRRAILINGSG,X
   BEQ +
   CMP #4
   BCC STOREUM
   STA TRAILUF,Y
   INX
   INY
   BNE -
+  LDA #<TRAILUF
   LDX #>TRAILUF
   STA ZP+0
   STX ZP+1
   TYA
   LDY #0
   LDX #STDOUT
   JMP WRITE

   STOREUM = *
   STX WORK+0
   STY WORK+1
   SEC
   SBC #1
   ASL
   ASL
   ADC #DIRILES
   TAX
   LDA #<UTOAUMBER
   LDY #>UTOAUMBER
   STA ZP+0
   STY ZP+1
   LDA #1
   JSR UTOA
   LDX #0
   LDY WORK+1
-  LDA UTOAUMBER,X
   BEQ +
   STA TRAILUF,Y
   INX
   INY
   BNE -
+  LDX WORK+0
   INX
   JMP --

   DIRRAILINGSG = *
   .ASC "FILES="
   .BYTE 1
   .ASC "  BYTES="
   .BYTE 2
   .ASC "  FREE="
   .BYTE 3
   .BYTE CHR
   .BYTE 0

   TRAILUF .BUF 64

PUTNATE = *
   ;** YEAR
   LDA ACEIRENTATE+1
   LDX #9
   JSR PUTIGITS
   ;** MONTH
   LDA ACEIRENTATE+2
   CMP #$10
   BCC +
   SEC
   SBC #$10-10
+  TAX
   LDA MONTHTR+0,X
   STA DIRATETR+5
   LDA MONTHTR+13,X
   STA DIRATETR+6
   LDA MONTHTR+26,X
   STA DIRATETR+7
   ;** DAY
   LDA ACEIRENTATE+3
   LDX #2
   JSR PUTIGITS
   ;** HOUR
   LDA ACEIRENTATE+4
   LDX #"A"
   CMP #$00
   BNE +
   LDA #$12
   JMP PUTOUR
+  CMP #$12
   BCC PUTOUR
   LDX #"P"
   CMP #$12
   BEQ PUTOUR
   SEI
   SED
   SEC
   SBC #$12
   CLD
   CLI
   PUTOUR = *
   STX DIRATETR+18
   LDX #13
   JSR PUTIGITS
   ;** MINUTE
   LDA ACEIRENTATE+5
   LDX #16
   JSR PUTIGITS
   RTS

   PUTIGITS = *  ;( .=NUM, .=OFFSET )
   PHA
   LSR
   LSR
   LSR
   LSR
   ORA #$30
   STA DIRATETR,X
   PLA
   AND #$0F
   ORA #$30
   STA DIRATETR+1,X
   RTS
 
   MONTHTR = *
   .ASC ""
   .ASC "XAEAPAUUUECOE"
   .ASC "XNBRRYNLGPTVC"

;******** STANDARD LIBRARY ********
PUTS = *
   LDX #STDOUT
FPUTS = *
   STA ZP
   STY ZP+1
   LDY #$FF
-  INY
   LDA (ZP),Y
   BNE -
   TYA
   LDY #0
   JMP WRITE
EPUTS = *
   LDX #STDERR
   JMP FPUTS

PUTCHAR = *
   LDX #STDOUT
PUTC = *
   STA PUTCUFFER
   LDA #<PUTCUFFER
   LDY #>PUTCUFFER
   STA ZP
   STY ZP+1
   LDA #1
   LDY #0
   JMP WRITE
   PUTCUFFER .BUF 1

GETARG = *
   STY ZP+1
   ASL
   STA ZP
   ROL ZP+1
   CLC
   LDA ACERGV
   ADC ZP
   STA ZP
   LDA ACERGV+1
   ADC ZP+1
   STA ZP+1
   LDY #0
   LDA (ZP),Y
   TAX
   INY
   LDA (ZP),Y
   STX ZP
   STA ZP+1
   RTS

UTOAUMBER .BUF 11

;===BSS===

BSS = *
